> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tenbyte.io/llms.txt
> Use this file to discover all available pages before exploring further.

# VM parameters

> Describes VM creation parameters and their expected and allowed values.



## OpenAPI

````yaml https://raw.githubusercontent.com/vidinfra/open-api-docs/refs/heads/main/cloud-api.json get /api/parameters/vm
openapi: 3.0.0
info:
  title: Tenbyte Cloud API
  version: 1.0.0
  description: >-
    API for managing cloud resources like Virtual Machines, Storage, Networks,
    and more on tenbytecloud.com.
servers:
  - url: https://api.tenbytecloud.com/v1
    description: Production server
security:
  - apikey-header-apikey: []
tags:
  - name: User
    description: User profile and SSH key management
  - name: Token
    description: API token management
  - name: Locations
    description: Available data centre locations
  - name: VM
    description: Virtual machine management
  - name: Block Storage
    description: Block storage disk management
  - name: Object Storage
    description: S3-compatible object storage management
  - name: Private networks
    description: Private network management
  - name: Floating IP
    description: Floating IP address management
  - name: Firewall
    description: Firewall management
  - name: Network Load Balancer
    description: Network load balancer management
  - name: Parameters
    description: VM creation parameters and image lists
paths:
  /api/parameters/vm:
    get:
      tags:
        - Parameters
      summary: VM parameters
      description: Describes VM creation parameters and their expected and allowed values.
      operationId: getVmParameters
      responses:
        '200':
          description: List of VM parameter constraints
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
              example:
                - constraint: range
                  description: Size of main storage in gigabytes.
                  mandatory: true
                  max: 240
                  min: 20
                  parameter: disks
                  type: integer
                - constraint: regexp
                  description: Name of the VM
                  expression: ^[0-9a-zA-Z][-0-9a-zA-Z]{2,}[0-9a-zA-Z]$
                  mandatory: true
                  parameter: name
                  type: string
                - constraint: enum
                  description: OS name of VM base image.
                  mandatory: true
                  parameter: os_name
                  type: string
                  values:
                    - centos
                    - ubuntu
                    - windows
                    - debian
                - constraint: enum
                  description: OS version of VM base image.
                  limited_by: os_name
                  mandatory: true
                  parameter: os_version
                  type: string
                - constraint: regexp
                  description: Password for logging in to the VM.
                  expression: ^(?=.*[a-z])(?=.*[A-Z])(?=.*\d).{8,}$
                  mandatory: true
                  parameter: password
                  type: string
                - constraint: range
                  description: Amount of RAM.
                  mandatory: true
                  max: 65536
                  min: 512
                  parameter: ram
                  type: integer
                - constraint: regexp
                  description: Username for logging in to the VM.
                  mandatory: true
                  parameter: username
                  type: string
                - constraint: range
                  description: Number of CPUs.
                  mandatory: true
                  max: 16
                  min: 1
                  parameter: vcpu
                  type: integer
      security:
        - apikey-header-apikey: []
components:
  securitySchemes:
    apikey-header-apikey:
      type: apiKey
      in: header
      name: apikey

````